<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Symbol Tables</TITLE>
<link href="suif1_41.html" rel=Next>
<link href="suif1_39.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_39.html">previous</A>, <A HREF="suif1_41.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC40" HREF="suif1_toc.html#TOC40">Symbol Tables</A></H1>
<P>
<A NAME="IDX260"></A>

</P>
<P>
Symbol tables contain the definitions of the symbols and types used
within a SUIF program.  Each symbol table is associated with an object
corresponding to a particular scope.  For example, a procedure symbol
table is attached to the abstract syntax tree representing the body of
the procedure.  The symbol tables can be reached through the
corresponding objects and vice versa.

</P>
<P>
This section describes the symbol table hierarchy and the details of the
symbol table operations, such as looking up symbol table entries and
adding new entries.  It also explains how the symbol tables handle the
task of assigning unique ID numbers to the symbols and types.  The
<TT>`symtab.h'</TT> and <TT>`symtab.cc'</TT> files contain the code for symbol
tables.

</P>

<UL>
<LI><A HREF="suif1_41.html#SEC41">Symbol Table Hierarchy</A>: Different kinds of symbol tables.
<LI><A HREF="suif1_46.html#SEC46">Basic Symtab Features</A>: Basic features common to all symbol tables.
<LI><A HREF="suif1_47.html#SEC47">Lookup Methods</A>: Finding symbol table entries.
<LI><A HREF="suif1_48.html#SEC48">Creating New Entries</A>: Creating new objects in a symbol table.
<LI><A HREF="suif1_49.html#SEC49">Adding and Removing Entries</A>: Changing the symbol table contents.
<LI><A HREF="suif1_50.html#SEC50">Numbering Types and Symbols</A>: Assigning ID numbers to types and symbols.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_39.html">previous</A>, <A HREF="suif1_41.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
